# -----------------------------------------#
#         GJ 3 Points light V0.1           #
# by Guillaume Jobst : www.guillaume-j.com #
#         contact@guillaume-j.com          #
# -----------------------------------------#


import maya.cmds as mc

# --------------------------------

#Create KeyLight Path
mc.circle ( n="PathKey", nr=(0,1,0), r=11.4)

#Create FillLight Path
mc.circle ( n="PathFill", nr=(0,1,0), r=11.4)

#Create RimLight Path
mc.circle ( n="PathRim", nr=(0,1,0), r=11.4)

#Create Control Curve
mc.circle ( n="Controls", nr=(0,1,0), r=5)

# --------------------------------

#Create Custom Attribut

#Key Attribut

mc.addAttr( longName="KeyLight", numberOfChildren=12, attributeType='compound' )

mc.addAttr ( attributeType="float", longName="KeyLightPos", minValue = 0, maxValue = 360, defaultValue = 0, parent="KeyLight" )
mc.addAttr ( attributeType="float", longName="KeyLightUp", softMinValue = -10, softMaxValue = 10, defaultValue = 8.294, parent="KeyLight" )

mc.addAttr ( attributeType="float", longName="KeyLight_Intensity", softMinValue = 0, softMaxValue = 1, defaultValue = 1, shortName="keyInt", parent="KeyLight" )

mc.addAttr( longName="KeyLight_Color", usedAsColor=True, attributeType='float3', parent="KeyLight" )
mc.addAttr( longName="KeyLight_Color_R", attributeType='float', defaultValue = 1, parent='KeyLight_Color' )
mc.addAttr( longName="KeyLight_Color_G", attributeType='float', defaultValue = 1, parent='KeyLight_Color' )
mc.addAttr( longName="KeyLight_Color_B", attributeType='float', defaultValue = 1, parent='KeyLight_Color' )

mc.addAttr ( attributeType="float", longName="KeyLight_ConeAngle", softMinValue = 0, softMaxValue = 100, defaultValue = 40, shortName="Cone_Angle", parent="KeyLight" )

mc.addAttr ( attributeType="float", longName="KeyLight_PenumbraAngle", softMinValue = -10, softMaxValue = 10, defaultValue = 0, shortName="KeyLight_PenumbraAngle", parent="KeyLight" )

mc.addAttr ( attributeType="float", longName="KeyLight_Dropoff", softMinValue = 0, softMaxValue = 255, defaultValue = 0, shortName="KeyLight_Dropoff", parent="KeyLight" )

mc.addAttr ( attributeType="bool", longName="KeyLightUseRaytraceShadow", defaultValue = 1, shortName="KeyLightUseRaytraceShadow", parent="KeyLight" )
mc.addAttr ( attributeType="float", longName="KeyLight_Lightradius", softMinValue = 0, softMaxValue = 100, defaultValue = 0, shortName="KeyLight_Lightradius", parent="KeyLight" )
mc.addAttr ( attributeType="long", longName="KeyLight_ShadowRays", softMinValue = 0, softMaxValue = 100, defaultValue = 1, shortName="KeyLight_ShadowRays", parent="KeyLight" )


mc.addAttr ( attributeType="bool", longName="KeyLightUseDepthMapShadows", defaultValue = 0, shortName="KeyLightUseDepthMapShadow", parent="KeyLight" )
mc.addAttr ( attributeType="long", longName="KeyLight_ShadowResolution", softMinValue = 0, softMaxValue = 8192, defaultValue = 512, shortName="KeyLight_ShadowResolution", parent="KeyLight" )

#Fill Attribut

mc.addAttr( longName="FillLight", numberOfChildren=12, attributeType='compound' )

mc.addAttr ( attributeType="float", longName="FillLightPos", minValue = 0, maxValue = 360, defaultValue = 0, parent="FillLight" )
mc.addAttr ( attributeType="float", longName="FillLightUp", softMinValue = -10, softMaxValue = 10, defaultValue = 3.237, parent="FillLight" )

mc.addAttr ( attributeType="float", longName="FillLight_Intensity",softMinValue = 0, softMaxValue = 1,defaultValue = 0.5, shortName="FillInt", parent="FillLight")

mc.addAttr( longName="FillLight_Color", usedAsColor=True, attributeType='float3', parent ="FillLight" )
mc.addAttr( longName="FillLight_Color_R", attributeType='float', defaultValue = 1, parent='FillLight_Color' )
mc.addAttr( longName="FillLight_Color_G", attributeType='float', defaultValue = 1, parent='FillLight_Color' )
mc.addAttr( longName="FillLight_Color_B", attributeType='float', defaultValue = 1, parent='FillLight_Color' )

mc.addAttr ( attributeType="float", longName="FillLight_ConeAngle", softMinValue = 0, softMaxValue = 100, defaultValue = 40, shortName="FillLightConeAngle", parent="FillLight" )

mc.addAttr ( attributeType="float", longName="FillLight_PenumbraAngle", softMinValue = -10, softMaxValue = 10, defaultValue = 0, shortName="FillLight_PenumbraAngle", parent="FillLight" )

mc.addAttr ( attributeType="float", longName="FillLight_Dropoff", softMinValue = 0, softMaxValue = 255, defaultValue = 0, shortName="FillLight_Dropoff", parent="FillLight" )

mc.addAttr ( attributeType="bool", longName="FillLightUseRaytraceShadow", defaultValue = 0, shortName="FillLightUseRaytraceShadow", parent="FillLight" )
mc.addAttr ( attributeType="float", longName="FillLight_Lightradius", softMinValue = 0, softMaxValue = 100, defaultValue = 0, shortName="FillLight_Lightradius", parent="FillLight" )
mc.addAttr ( attributeType="long", longName="FillLight_ShadowRays", softMinValue = 0, softMaxValue = 100, defaultValue = 1, shortName="FillLight_ShadowRays", parent="FillLight" )

mc.addAttr ( attributeType="bool", longName="FillLightUseDepthMapShadows", defaultValue = 0, shortName="FillLightUseDepthMapShadow", parent="FillLight" )
mc.addAttr ( attributeType="long", longName="FillLight_ShadowResolution", softMinValue = 0, softMaxValue = 8192, defaultValue = 512, shortName="FillLight_ShadowResolution", parent="FillLight" )

#Rim Attribut

mc.addAttr( longName="RimLight", numberOfChildren=12, attributeType='compound' )

mc.addAttr ( attributeType="float", longName="RimLightPos", minValue = 0, maxValue = 360, defaultValue = 0, parent="RimLight" )
mc.addAttr ( attributeType="float", longName="RimLightUp", softMinValue = -10, softMaxValue = 10, defaultValue = 4.994, parent="RimLight" )


mc.addAttr ( attributeType="float", longName="BackLight_Intensity",softMinValue = 0, softMaxValue = 1, defaultValue = 0.6, shortName="BackInt", parent= "RimLight")

mc.addAttr( longName="BackLight_Color", usedAsColor=True, attributeType='float3', parent = "RimLight" )
mc.addAttr( longName="BackLight_Color_R", attributeType='float', defaultValue = 1, parent='BackLight_Color' )
mc.addAttr( longName="BackLight_Color_G", attributeType='float', defaultValue = 1, parent='BackLight_Color' )
mc.addAttr( longName="BackLight_Color_B", attributeType='float', defaultValue = 1, parent='BackLight_Color' )

mc.addAttr ( attributeType="float", longName="RimLight_ConeAngle", softMinValue = 0, softMaxValue = 100, defaultValue = 40, shortName="RimLightConeAngle", parent="RimLight" )

mc.addAttr ( attributeType="float", longName="RimLight_PenumbraAngle", softMinValue = -10, softMaxValue = 10, defaultValue = 0, shortName="RimLight_PenumbraAngle", parent="RimLight" )

mc.addAttr ( attributeType="float", longName="RimLight_Dropoff", softMinValue = 0, softMaxValue = 255, defaultValue = 0, shortName="RimLight_Dropoff", parent="RimLight" )

mc.addAttr ( attributeType="bool", longName="RimLightUseRaytraceShadow", defaultValue = 0, shortName="RimLightUseRaytraceShadow", parent="RimLight" )
mc.addAttr ( attributeType="float", longName="RimLight_Lightradius", softMinValue = 0, softMaxValue = 100, defaultValue = 0, shortName="RimLight_Lightradius", parent="RimLight" )
mc.addAttr ( attributeType="long", longName="RimLight_ShadowRays", softMinValue = 0, softMaxValue = 100, defaultValue = 1, shortName="RimLight_ShadowRays", parent="RimLight" )


mc.addAttr ( attributeType="bool", longName="RimLightUseDepthMapShadows", defaultValue = 0, shortName="RimLightUseDepthMapShadow", parent="RimLight" )
mc.addAttr ( attributeType="long", longName="RimLight_ShadowResolution", softMinValue = 0, softMaxValue = 8192, defaultValue = 512, shortName="RimLight_ShadowResolution", parent="RimLight" )

# MR Background Camera Attribut for FG

mc.addAttr( longName="Camera", numberOfChildren=1, attributeType='compound' )

mc.addAttr( longName="Background_Color", usedAsColor=True, attributeType='float3', parent = "Camera")
mc.addAttr( longName="Background_Color_R", attributeType='float', defaultValue = 0.5, parent='Background_Color' )
mc.addAttr( longName="Background_Color_G", attributeType='float', defaultValue = 0.5, parent='Background_Color' )
mc.addAttr( longName="Background_Color_B", attributeType='float', defaultValue = 0.5, parent='Background_Color' )

# --------------------------------

#Keylight Creation

mc.spotLight( n="Keylight", rs=True, i = 0.9 )

mc.move ( -6.987, 8.374293, 8.98, r=True)

mc.expression ( s="KeylightShape.intensity = Controls.KeyLight_Intensity" )

mc.expression ( s="KeylightShape.colorR = Controls.KeyLight_Color_R" )
mc.expression ( s="KeylightShape.colorG = Controls.KeyLight_Color_G" )
mc.expression ( s="KeylightShape.colorB = Controls.KeyLight_Color_B" )

mc.expression ( s="KeylightShape.coneAngle = Controls.KeyLight_ConeAngle" )
mc.expression ( s="KeylightShape.penumbraAngle = Controls.KeyLight_PenumbraAngle" )
mc.expression ( s="KeylightShape.dropoff = Controls.KeyLight_Dropoff" )

mc.expression ( s= "KeylightShape.useRayTraceShadows = Controls.KeyLightUseRaytraceShadow" )
mc.expression ( s= "KeylightShape.lightRadius = Controls.KeyLight_Lightradius" )
mc.expression ( s= "KeylightShape.shadowRays = Controls.KeyLight_ShadowRays" )


mc.expression ( s= "KeylightShape.useDepthMapShadows = Controls.KeyLightUseDepthMapShadows" )
mc.expression ( s= "KeylightShape.dmapResolution = Controls.KeyLight_ShadowResolution" )

mc.expression ( s= "PathKey.rotateY = Controls.KeyLightPos" )
mc.expression ( s= "PathKey.translateY = Controls.KeyLightUp" )


mc.parentConstraint (  "PathKey" , "Keylight" , skipRotate = ("x", "y", "z" ), maintainOffset=True )

# --------------------------------

#Filllight Creation

mc.spotLight( n="FillLight", i = 0.4 )

mc.move ( 11.058, 3.316, 3.034, r=True)

mc.expression ( s="FillLightShape.intensity = Controls.FillLight_Intensity" )

mc.expression ( s="FillLightShape.colorR = Controls.FillLight_Color_R" )
mc.expression ( s="FillLightShape.colorG = Controls.FillLight_Color_G" )
mc.expression ( s="FillLightShape.colorB = Controls.FillLight_Color_B" )

mc.expression ( s="FillLightShape.coneAngle = Controls.FillLight_ConeAngle" )
mc.expression ( s="FillLightShape.penumbraAngle = Controls.FillLight_PenumbraAngle" )
mc.expression ( s="FillLightShape.dropoff = Controls.FillLight_Dropoff" )

mc.expression ( s= "FillLightShape.useRayTraceShadows = Controls.FillLightUseRaytraceShadow" )
mc.expression ( s= "FillLightShape.lightRadius = Controls.FillLight_Lightradius" )
mc.expression ( s= "FillLightShape.shadowRays = Controls.FillLight_ShadowRays" )


mc.expression ( s= "FillLightShape.useDepthMapShadows = Controls.FillLightUseDepthMapShadows" )
mc.expression ( s= "FillLightShape.dmapResolution = Controls.FillLight_ShadowResolution" )

mc.expression ( s= "PathFill.rotateY = Controls.FillLightPos" )
mc.expression ( s= "PathFill.translateY = Controls.FillLightUp" )


mc.parentConstraint (  "PathFill" , "FillLight" , skipRotate = ("x", "y", "z" ), maintainOffset=True )

# --------------------------------

#RimLight Creation

mc.spotLight( n="RimLight", i = 0.5 )

mc.move ( 0, 4.969, -11.322, r=True)

mc.expression ( s="RimLightShape.intensity = Controls.BackLight_Intensity" )

mc.expression ( s="RimLightShape.colorR = Controls.BackLight_Color_R" )
mc.expression ( s="RimLightShape.colorG = Controls.BackLight_Color_G" )
mc.expression ( s="RimLightShape.colorB = Controls.BackLight_Color_B" )

mc.expression ( s="RimLightShape.coneAngle = Controls.RimLight_ConeAngle" )
mc.expression ( s="RimLightShape.penumbraAngle = Controls.RimLight_PenumbraAngle" )
mc.expression ( s="RimLightShape.dropoff = Controls.RimLight_Dropoff" )

mc.expression ( s= "RimLightShape.useRayTraceShadows = Controls.RimLightUseRaytraceShadow" )
mc.expression ( s= "RimLightShape.lightRadius = Controls.RimLight_Lightradius" )
mc.expression ( s= "RimLightShape.shadowRays = Controls.RimLight_ShadowRays" )

mc.expression ( s= "RimLightShape.useDepthMapShadows = Controls.RimLightUseDepthMapShadows" )
mc.expression ( s= "RimLightShape.dmapResolution = Controls.RimLight_ShadowResolution" )

mc.expression ( s= "PathRim.rotateY = Controls.RimLightPos" )
mc.expression ( s= "PathRim.translateY = Controls.RimLightUp" )

mc.parentConstraint (  "PathRim" , "RimLight" , skipRotate = ("x", "y", "z" ), maintainOffset=True )

# --------------------------------

#Hide Path
mc.hide ( "PathRim" , "PathFill" , "PathKey" )

# --------------------------------

#Camera Creation

mc.camera ( n="Camera3Points")

mc.move ( 0, 2.429, 8.952, r=True)

mc.rotate ( -9.476, 0, 0, os=True )

# --------------------------------

#Locator central creation

mc.spaceLocator ( n="CentralPoint", p= (0,0,0) )

#AIM creation

mc.aimConstraint ( "CentralPoint", "Keylight", o=(0,-90,0) )
mc.aimConstraint ( "CentralPoint", "FillLight", o=(0,-90,0) )
mc.aimConstraint ( "CentralPoint", "RimLight", o=(0,-90,0) )

# --------------------------------

#Group Creation

mc.group ( "Keylight", "FillLight", "RimLight", "CentralPoint", "Camera3Points1", "Controls", "PathRim" , "PathFill" , "PathKey", a=True, n="GJ_3PointsLightGroup")
mc.xform ( t=(0,0,0), sp=(0,0,0), rp=(0,0,0), ws=True )

# --------------------------------

#Change FG Color
mc.select ("Camera3PointsShape2")
mc.expression ( s= "Camera3PointsShape2.backgroundColorR = Controls.Background_Color_R")
mc.expression ( s= "Camera3PointsShape2.backgroundColorG = Controls.Background_Color_G")
mc.expression ( s= "Camera3PointsShape2.backgroundColorB = Controls.Background_Color_B")


